/* RC5 decoding routines
 */
#include <rational>

#if !defined RC5Group
    const RC5Group = 0
#endif

rc5_init(pin)
    {
    /* an RC5 frame takes approximately 25 ms, so set up I/O pin 11
     * for sampling for a duration of 25 ms
     */
    configiopin pin, Sample, 25
    }

@sample(const Fixed:stamps[], numsamples)
    {
    /* a single bit in RC5 takes a "time slot" of 1.778 milliseconds */
    const Fixed:rc5interval = 1.778

    new code = 0, curbit = 1

    /* first do the raw decoding, and store it in a single cell */
    new Fixed:stamp = rc5interval / 4
    new sample = 0
    for (new i = 0; i < 14; i++)
        {
        code = (code << 1) | curbit
        stamp += rc5interval
        while (sample < numsamples && stamps[sample] <= stamp)
            {
            curbit ^= 1
            sample++
            }
        }

    /* we accept only codes that begin with 2 start bits, and that belong
     * to the correct group
     */
    if ((code & ~0x83f) == (0x3000 | (RC5Group << 6)))
        {
        /* extract the current toggle and determine whether this is
         * a repeated command
         */
        static CurrentToggle = -1
        new togglebit = (code & 0x800)
        new repeat = (togglebit == CurrentToggle)
        CurrentToggle = togglebit

        /* send the command */
        rc5handler code & 0x3f, repeat
        }
    }

